Subject: Re: bug#60845: 30.0.50; [PATCH] Add tests for Eshell interactive completion (and fix a bug in it)

From: Jim Porter <[email-masked]>
Date: Sun, 22 Jan 2023 13:34:44 -0800

X-Debbugs-CC: [email-masked]

On 1/15/2023 5:50 PM, Jim Porter wrote:
> This is a followup from bug#60464 and friends. Over there, we discussed 
> problems with Pcomplete when used from Eshell, namely that Eshell 
> sometimes gives Pcomplete non-string arguments. I mentioned that we 
> should probably have automated tests for the Eshell side so that we can 
> make further improvements to Pcomplete without causing regressions, so 
> here are some tests.

After studying how Eshell interfaces with Pcomplete, I think I've 
convinced myself that Eshell should be the one responsible for 
converting all its arguments to strings. It already does this for some 
cases (nil becomes "", numbers are stringified, and ".../" forms become 
"../../"), so the fact that it doesn't do this universally is probably a 
bug.

The third patch in this series fixes this for the Eshell side, so we 
could probably remove the workaround in pcomplete.el for Emacs 30.